//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

void DoTrallingStop(int TStop=-1,int TStep=-1){
   Fncs++;
   if(TStop==-1) TStop=TrallingStop;
   if(TStep==-1) TStep=TrallingStep;
   double SL;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()){
         if(OrderType()==OP_BUY && Bid>OrderOpenPrice()+TStop*Point+TStep*Point){
            SL=0;
            if(OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice()) SL=OrderOpenPrice();
            if(OrderStopLoss()!=0 && OrderStopLoss()>=OrderOpenPrice() && Bid>=OrderStopLoss()+TStop*Point+TStep*Point) SL=Bid-TStop*Point;
            if(SL!=0 && SL!=OrderStopLoss()){
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0);
               if(UseSound==true) PlaySound(SND_Modify);
               PlaceMask(DoubleToStr(OrderTicket(),0),1,SL);
               }
            }
         if(OrderType()==OP_SELL && Ask<OrderOpenPrice()-TStop*Point-TStep*Point){
            SL=0;
            if(OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice()) SL=OrderOpenPrice();
            if(OrderStopLoss()!=0 && OrderStopLoss()<=OrderOpenPrice() && Ask<=OrderStopLoss()-TStop*Point-TStep*Point) SL=Ask+TStep*Point;
            if(SL!=0 && SL!=OrderStopLoss()){
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0);
               if(UseSound==true) PlaySound(SND_Modify);
               PlaceMask(DoubleToStr(OrderTicket(),0),1,SL);
               }
            }
         }
      }
   return;
   }

void DoPendTrall(int PTStop=-1,int PTStep=-1){
   Fncs++;
   double Proc,SL,TP;
   if(PTStop==-1) PTStop=PendTrallingStop;
   if(PTStep==-1) PTStep=PendTrallingStep;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()){
         if(OrderType()==OP_BUYSTOP){
            if(Ask<OrderOpenPrice()-PTStop*Point-PTStep*Point){
               Proc=(Ask+PTStop*Point)-OrderOpenPrice();
               if(OrderStopLoss()>0) SL=OrderStopLoss()+Proc;
               if(OrderTakeProfit()>0) TP=OrderTakeProfit()+Proc;
               OrderModify(OrderTicket(),OrderOpenPrice()+Proc,SL,TP,0);
               PlaceMask(DoubleToStr(OrderTicket(),0),0,OrderOpenPrice()+Proc);
               PlaceMask(DoubleToStr(OrderTicket(),0),1,SL);
               PlaceMask(DoubleToStr(OrderTicket(),0),2,TP);
               }
            }
         if(OrderType()==OP_SELLSTOP){
            if(Bid>OrderOpenPrice()+PTStop*Point+PTStep*Point){
               Proc=(Bid-PTStop*Point)-OrderOpenPrice();
               if(OrderStopLoss()>0) SL=OrderStopLoss()+Proc;
               if(OrderTakeProfit()>0) TP=OrderTakeProfit()+Proc;
               OrderModify(OrderTicket(),OrderOpenPrice()+Proc,SL,TP,0);
               PlaceMask(DoubleToStr(OrderTicket(),0),0,OrderOpenPrice()+Proc);
               PlaceMask(DoubleToStr(OrderTicket(),0),1,SL);
               PlaceMask(DoubleToStr(OrderTicket(),0),2,TP);
               }
            }
         }
      }
   return;
   }



void Reverse2Check(){
   Fncs++;
   if(Sells()>0){
      DeleteBuyStops();
      }
   if(Buys()>0){
      DeleteSellStops();
      }
   }

void CheckLines(){
   Fncs++;
   for(int i=1;i<=LineLimit;i++){
      if(ObjectFind("__LineStop_UP"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Ask)
            {
            OpBuy();
            ObjectDelete("__LineStop_UP"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineStop_DN"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Bid)
            {
            OpSell();
            ObjectDelete("__LineStop_DN"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineExit_UP"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Ask)
         CloseSells();
         if(ObjectGet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Bid){
            CloseBuys();
            ObjectDelete("__LineExit_UP"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineExit_DN"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Bid)
         CloseBuys();
         if(ObjectGet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Ask){
            CloseSells();
            ObjectDelete("__LineExit_DN"+DoubleToStr(i,0));
            }
         }
      }
   }

void TickEvent(){
   Fncs++;
   int j;
   if(XProfit>0){
      for(int i=OrdersTotal()-1;i>=0;i--){
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol()==Symbol()){
            if(OrderType()==OP_BUY){
               RefreshRates();
               if(Bid>=OrderOpenPrice()+XProfit*Point){
                  CloseNow(OrderTicket());
                  }
               }
            if(OrderType()==OP_SELL){
               RefreshRates();
               if(Ask<=OrderOpenPrice()-XProfit*Point){
                  CloseNow(OrderTicket());
                  }
               }
            }
         }
      }
   return;
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+

