//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

void LiveStatics(){
   Fncs++;
   Stat_Title[ST_INF1]="";
   Stat_Title[ST_INF2]="";
   Stat_Title[ST_INF3]="";
   
   string AB=DoubleToStr(AccountBalance(),2);
   string EQ=DoubleToStr(AccountEquity(),2);
   string PF=DoubleToStr(AccountProfit(),2);
   string FM=DoubleToStr(AccountFreeMargin(),2);
   string SS=DoubleToStr(MarketInfo(Symbol(),MODE_SPREAD),0)+"/"+DoubleToStr(MarketInfo(Symbol(),MODE_STOPLEVEL),0);
   //string OK=DoubleToStr(StoimPunkt(Symbol())*Lots*XProfit,2);
   
   Stat_Title[ST_BLV]=AB;
   Stat_Title[ST_EQV]=EQ;
   Stat_Title[ST_PRV]=PF;
   Stat_Title[ST_SSV]=SS;
   Stat_Title[ST_FMV]=FM;
   //Stat_Title[ST_OK]=OK;
   
   color Prof;
   
   if(AccountProfit()>0) Prof=CL_Good;
   if(AccountProfit()<0) Prof=CL_Bad;
   if(AccountProfit()==0) Prof=CL_Text;
   
   Stat_Color[ST_PRV]=Prof;
   Stat_Color[ST_PRT]=Prof;
   
   RefreshRates();
   int Prom=Time[1]-Time[2];
   int Step=TimeCurrent()-Time[0];
   int Left=Prom-Step;
   int Ind=(Left*50)/((Prom*50)/STAT_L);
   
   string Ff1="";
   for(int i=1;i<=Ind;i++){
      Ff1=Ff1+StatSym;
      }
   Stat_Title[ST_STAT]=Ff1;
   
   string Mns=DoubleToStr(Minute(),0);
   if(StringLen(Mns)==1) Mns="0"+Mns;
   string Sns=DoubleToStr(Seconds(),0);
   if(StringLen(Sns)==1) Sns="0"+Sns;
   string Tms=DoubleToStr(Hour(),0)+":"+Mns+"."+Sns;
   Stat_Title[ST_TIME]=Tms;
   
   int Reqt=TimeCurrent()-TimeStart;
   int Sc=Reqt%60;
   int Mn=TimeMinute(Reqt);
   int Hr=TimeHour(Reqt);
   string Ds=DoubleToStr(Reqt/(3600*24),0);
   if(Ds=="0") Ds=""; else Ds=Ds+"-";
   
   string Mts=DoubleToStr(Mn,0);
   if(StringLen(Mts)==1) Mts="0"+Mts;
   
   string Tmq=Ds+DoubleToStr(Hr,0)+":"+Mts;
   
   
   Stat_Title[ST_REQS]="Requests: "+DoubleToStr(Reqs,0)+" ["+Tmq+"]";
   
   return;
   }

void RefStatics(){
   Fncs++;
   for(int i=1;i<=StatLastID;i++){
      if(Stat_Visible[i]==1){
         if(ObjectFind(Stat_Name[i])==-1) ObjectCreate(Stat_Name[i],OBJ_LABEL,Stat_Window[i],0,0);
         ObjectSet(Stat_Name[i],OBJPROP_CORNER,Stat_Corner[i]);
         ObjectSetText(Stat_Name[i],Stat_Title[i],Stat_FontSize[i],Stat_Font[i],Stat_Color[i]);
         ObjectSet(Stat_Name[i],OBJPROP_XDISTANCE,Stat_PosX[i]);
         ObjectSet(Stat_Name[i],OBJPROP_YDISTANCE,Stat_PosY[i]);
         }
      }
   }

void UsePresets(){
   Fncs++;
   int Tmp;
   PresetsCheck();
   if(ObjectFind(Pres_Name[PR_LOTS])!=-1) Lots=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_LOTS])),2);
   if(Lots>MarketInfo(Symbol(),MODE_MAXLOT)) Lots=MarketInfo(Symbol(),MODE_MAXLOT);
   if(Lots<MarketInfo(Symbol(),MODE_MINLOT)) Lots=MarketInfo(Symbol(),MODE_MINLOT);
   Pres_Title[PR_LOTS]=DoubleToStr(Lots,2);
   
   if(ObjectFind(Pres_Name[PR_RISK])!=-1) Risk=StrToDouble(ObjectDescription(Pres_Name[PR_RISK]));
   if(Risk>100) Risk=100;
   if(Risk<0) Risk=0;
   Pres_Title[PR_RISK]=DoubleToStr(Risk,0);
   
   if(Risk>0){
      double Min=MarketInfo(Symbol(),MODE_MINLOT);
      double Max=MarketInfo(Symbol(),MODE_MAXLOT);
      double Req=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
      double Free=AccountFreeMargin()/100*Risk;
      Lots=Free/Req;
      if(Lots<Min) Lots=Min;
      if(Lots>Max) Lots=Max;
      Lots=NormalizeDouble(Lots/MarketInfo(Symbol(),MODE_LOTSTEP),0);
      Lots=Lots*MarketInfo(Symbol(),MODE_LOTSTEP);
      Pres_Title[PR_LOTS]=DoubleToStr(Lots,2);
      if(Pres_Visible[PR_LOTS]==1) VisiblePreset(PR_LOTS);
      PlacePreset(PR_LOTS);
      }
   
   if(ObjectFind(Pres_Name[PR_SL])!=-1) StopLoss=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_SL])),0);
   Pres_Title[PR_SL]=StopLoss;
   
   
   if(ObjectFind(Pres_Name[PR_TP])!=-1) TakeProfit=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_TP])),0);
   Pres_Title[PR_TP]=TakeProfit;
   
   if(ObjectFind(Pres_Name[PR_TRALL])!=-1) TrallingStop=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_TRALL])),0);
   Pres_Title[PR_TRALL]=TrallingStop;
   
   if(ObjectFind(Pres_Name[PR_STEP])!=-1) TrallingStep=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_STEP])),0);
   Pres_Title[PR_STEP]=TrallingStep;
   
   if(ConsolePT==true){
   if(ObjectFind(Pres_Name[PR_PTRALL])!=-1) PendTrallingStop=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_PTRALL])),0);
   Pres_Title[PR_PTRALL]=PendTrallingStop;
   
   if(ObjectFind(Pres_Name[PR_PSTEP])!=-1) PendTrallingStep=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_PSTEP])),0);
   Pres_Title[PR_PSTEP]=PendTrallingStep;
   }
   if(ObjectFind(Pres_Name[PR_XP])!=-1) XProfit=NormalizeDouble(StrToDouble(ObjectDescription(Pres_Name[PR_XP])),0);
   Pres_Title[PR_XP]=XProfit;
   Stat_Title[ST_OK]=DoubleToStr(StoimPunkt(Symbol())*Lots*XProfit,2);
   
   if(ObjectFind("C_Sound")!=-1){
      if(ObjectGet("C_Sound",OBJPROP_COLOR)==CL_FlagOn) UseSound=true;
      if(ObjectGet("C_Sound",OBJPROP_COLOR)==CL_FlagOff) UseSound=false;
      }
   if(ObjectFind("P_Block")!=-1){
      if(ObjectGet("C_Block",OBJPROP_COLOR)==CL_FlagOn) UseBlock=true;
      if(ObjectGet("C_Block",OBJPROP_COLOR)==CL_FlagOff) UseBlock=false;
      }
   if(ObjectFind("C_Masks")!=-1){
      if(ObjectGet("C_Masks",OBJPROP_COLOR)==CL_FlagOn) UseMasks=true;
      if(ObjectGet("C_Masks",OBJPROP_COLOR)==CL_FlagOff) UseMasks=false;
      }
   if(ObjectFind("C_Rev1")!=-1){
      if(ObjectGet("C_Rev1",OBJPROP_COLOR)==CL_FlagOn) Reverse=true;
      if(ObjectGet("C_Rev1",OBJPROP_COLOR)==CL_FlagOff) Reverse=false;
      }
   if(ObjectFind("C_Rev2")!=-1){
      if(ObjectGet("C_Rev2",OBJPROP_COLOR)==CL_FlagOn) Reverse2=true;
      if(ObjectGet("C_Rev2",OBJPROP_COLOR)==CL_FlagOff) Reverse2=false;
      }
   if(ObjectFind("P_Conf")!=-1){
      if(ObjectGet("P_Conf",OBJPROP_COLOR)==CL_FlagOn) UseConfirm=true;
      if(ObjectGet("P_Conf",OBJPROP_COLOR)==CL_FlagOff) UseConfirm=false;
      }
   
   StrPresets();
   return;
   }

void PresetsCheck(){
   Fncs++;
   for(int i=1;i<=PresLastID;i++){
      if(ObjectFind(Pres_Name[i])==-1 && Pres_Visible[i]==1){
         VisiblePreset(i);
         }
      else if(ObjectFind(Pres_Name[i])!=-1 && Pres_Visible[i]==1){
         Pres_Title[i]=ObjectDescription(Pres_Name[i]);
         }
      if(Pres_Visible[i]==1) PlacePreset(i);
      }
   return;
   }

void BkCommand(int ID,int x,int y,string Title,string Font,int FontSize,color Color){
   Fncs++;
   Com_BackTitle[ID]=Title;
   Com_BackPosX[ID]=x;
   Com_BackPosY[ID]=y;
   Com_BackFont[ID]=Font;
   Com_BackFontSize[ID]=FontSize;
   Com_BackColor[ID]=Color;
   return;
   }

void EraseCommands(){
   Fncs++;
   for(int i=1;i<=ComLastID;i++){
      if(ObjectFind(Com_Name[i])!=-1) ObjectDelete(Com_Name[i]);
      ObjectDelete("_"+Com_Name[i]);
      Com_Name[i]="";
      Com_BackTitle[i]="";
      }
   ComLastID=0;
   return;
   }

void ErasePresets(){
   Fncs++;
   for(int i=1;i<=PresLastID;i++){
      if(ObjectFind(Pres_Name[i])!=-1) ObjectDelete(Pres_Name[i]);
      Pres_Name[i]="";
      }
   PresLastID=0;
   }
void EraseStatics(){
   Fncs++;
   for(int i=1;i<=StatLastID;i++){
      if(ObjectFind(Stat_Name[i])!=-1) ObjectDelete(Stat_Name[i]);
      Stat_Name[i]="";
      }
   PresLastID=0;
   }
int CommandsCheck(){
   Fncs++;
   for(int i=1;i<=ComLastID;i++){
      //Print(i," ",Com_Visible[i]);
      if(Com_Name[i]!=""){
         if((ObjectFind(Com_Name[i])==-1 ||(ObjectFind("_"+Com_Name[i])==-1 && Com_BackTitle[i]!=""))&& Com_Visible[i]==1){
            VisibleCommand(i);
            PlaceCommand(i);
            }
         else if(ObjectFind(Com_Name[i])!=-1 && Com_Visible[i]==1){
            if(CheckPlaceCommand(i)==false){
               while(CheckPlaceCommand(i)==false) PlaceCommand(i);
               if(UseSound==true) PlaySound(SND_Click);
               if(UnSelectCom){
                  HideCommand(i);
                  VisibleCommand(i);
                  PlaceCommand(i);
                  }
               Comment(" ");
               return(i);
               }
            }
         }
      }
   for(i=1;i<=PresLastID;i++){
      //Print(i," ",Com_Visible[i]);
      if(Pres_Name[i]!=""){
         if((ObjectFind(Pres_Name[i])==-1)&& Pres_Visible[i]==1){
            VisiblePreset(i);
            PlacePreset(i);
            }
         else if(ObjectFind(Pres_Name[i])!=-1 && Pres_Visible[i]==1){
            if(CheckPlacePreset(i)!=0){
               int Coff;
               while(CheckPlacePreset(i)!=0){
                  if(CheckPlacePreset(i)==-1) Coff=0; else Coff=5000;
                  PlacePreset(i);
                  }
               if(UseSound==true) PlaySound(SND_Click);
               if(UnSelectPres){
                  HidePreset(i);
                  VisiblePreset(i);
                  PlacePreset(i);
                  }
               Comment(" ");
               return(5000+i+Coff);
               }
            }
         }
      }
   return(0);
   }

bool CheckPlaceCommand(int ID){
   Fncs++;
   if(ObjectFind(Com_Name[ID])==-1 && Com_Visible[ID]==1){
      VisibleCommand(ID);
      PlaceCommand(ID);
      return(true);
      }
   int x=ObjectGet(Com_Name[ID],OBJPROP_XDISTANCE);
   int y=ObjectGet(Com_Name[ID],OBJPROP_YDISTANCE);
   int x2=ObjectGet("_"+Com_Name[ID],OBJPROP_XDISTANCE);
   int y2=ObjectGet("_"+Com_Name[ID],OBJPROP_YDISTANCE);
   if((x!=Com_PosX[ID] || y!=Com_PosY[ID]) && ObjectFind(Com_Name[ID])!=-1) return(false);
   else if(Com_BackTitle[ID]!="" && ObjectFind("_"+Com_Name[ID])!=-1 &&(x2!=Com_BackPosX[ID] || y2!=Com_BackPosY[ID])) return(false);
   else return(true);
   }
int CheckPlacePreset(int ID){
   Fncs++;
   if(ObjectFind(Pres_Name[ID])==-1 && Pres_Visible[ID]==1){
      VisiblePreset(ID);
      PlacePreset(ID);
      return(0);
      }
   int x=ObjectGet(Pres_Name[ID],OBJPROP_XDISTANCE);
   int y=ObjectGet(Pres_Name[ID],OBJPROP_YDISTANCE);
   if((x!=Pres_PosX[ID] || y!=Pres_PosY[ID]) && ObjectFind(Pres_Name[ID])!=-1){
      if(x<Pres_PosX[ID]) return(-1);
      if(x>Pres_PosX[ID]) return(1);
      }
   else return(0);
   }
int SetCommand(string Name,int Window,int Corner,int x,int y,string Title,string Font="",int FontSize=NULL,color Color=NULL){
   Fncs++;
   if(FontSize==NULL) FontSize=15;
   if(Color==NULL) Color=Black;
   int n=ComLastID+1;
   Com_Name[n]=Name;
   string Com_Na=Com_Name[n];
   Com_Title[n]=Title;
   Com_Font[n]=Font;
   Com_FontSize[n]=FontSize;
   Com_Window[n]=Window;
   Com_Corner[n]=Corner;
   Com_Color[n]=Color;
   Com_PosX[n]=x;
   Com_PosY[n]=y;
   Com_Visible[n]=1;
   ComLastID++;
   return(n);
   }
int SetPreset(string Name,int Window,int Corner,int x,int y,string Title,string Font="",int FontSize=NULL,color Color=NULL){
   Fncs++;
   if(FontSize==NULL) FontSize=15;
   if(Color==NULL) Color=Black;
   int n=PresLastID+1;
   Pres_Name[n]=Name;
   Pres_Title[n]=Title;
   Pres_Font[n]=Font;
   Pres_FontSize[n]=FontSize;
   Pres_Window[n]=Window;
   Pres_Corner[n]=Corner;
   Pres_Color[n]=Color;
   Pres_PosX[n]=x;
   Pres_PosY[n]=y;
   Pres_Visible[n]=1;
   PresLastID++;
   return(n);
   }
int SetStatic(string Name,int Window,int Corner,int x,int y,string Title,string Font="",int FontSize=NULL,color Color=NULL){
   Fncs++;
   if(FontSize==NULL) FontSize=15;
   if(Color==NULL) Color=Black;
   int n=StatLastID+1;
   Stat_Name[n]=Name;
   Stat_Title[n]=Title;
   Stat_Font[n]=Font;
   Stat_FontSize[n]=FontSize;
   Stat_Window[n]=Window;
   Stat_Corner[n]=Corner;
   Stat_Color[n]=Color;
   Stat_PosX[n]=x;
   Stat_PosY[n]=y;
   Stat_Visible[n]=1;
   StatLastID++;
   return(n);
   }
void HideCommand(int ID){
   Fncs++;
   Com_Visible[ID]=0;
   ObjectDelete(Com_Name[ID]);
   ObjectDelete("_"+Com_Name[ID]);
   return;
   }

void HideStatic(int ID){
   Fncs++;
   Stat_Visible[ID]=0;
   ObjectDelete(Stat_Name[ID]);
   return;
   }

void HidePreset(int ID){
   Fncs++;
   Pres_Visible[ID]=0;
   ObjectDelete(Pres_Name[ID]);
   return;
   }

void ShowCommand(int ID){
   Fncs++;
   VisibleCommand(ID);
   PlaceCommand(ID);
   return;
   }
void VisibleCommand(int ID){
   Fncs++;
   Com_Visible[ID]=1;
   ObjectCreate(Com_Name[ID],OBJ_LABEL,Com_Window[ID],0,0);
   ObjectSet(Com_Name[ID],OBJPROP_CORNER,Com_Corner[ID]);
   ObjectSetText(Com_Name[ID],Com_Title[ID],Com_FontSize[ID],Com_Font[ID],Com_Color[ID]);
   if(Com_BackTitle[ID]!=""){
      string E="_"+Com_Name[ID];
      ObjectCreate(E,OBJ_LABEL,Com_Window[ID],0,0);
      ObjectSet("_"+Com_Name[ID],OBJPROP_CORNER,Com_Corner[ID]);
      ObjectSetText("_"+Com_Name[ID],Com_BackTitle[ID],Com_BackFontSize[ID],Com_BackFont[ID],Com_BackColor[ID]);
      }
   }
void VisiblePreset(int ID){
   Fncs++;
   Pres_Visible[ID]=1;
   if(Pres_Visible[ID]==1){
      ObjectCreate(Pres_Name[ID],OBJ_LABEL,Pres_Window[ID],0,0);
      ObjectSet(Pres_Name[ID],OBJPROP_CORNER,Pres_Corner[ID]);
      ObjectSetText(Pres_Name[ID],Pres_Title[ID],Pres_FontSize[ID],Pres_Font[ID],Pres_Color[ID]);
      }
   return;
   }
void PlaceCommand(int ID){
   Fncs++;
   ObjectSet(Com_Name[ID],OBJPROP_XDISTANCE,Com_PosX[ID]);
   ObjectSet(Com_Name[ID],OBJPROP_YDISTANCE,Com_PosY[ID]);
   ObjectSet("_"+Com_Name[ID],OBJPROP_XDISTANCE,Com_BackPosX[ID]);
   ObjectSet("_"+Com_Name[ID],OBJPROP_YDISTANCE,Com_BackPosY[ID]);
   return;
   }
void PlacePreset(int ID){
   Fncs++;
   ObjectSet(Pres_Name[ID],OBJPROP_XDISTANCE,Pres_PosX[ID]);
   ObjectSet(Pres_Name[ID],OBJPROP_YDISTANCE,Pres_PosY[ID]);
   return;
   }
void MakeVisible(){
   Fncs++;
   int i;
   for(i=1;i<=ComLastID;i++){
      if(Com_Visible[i]==1){
         VisibleCommand(i);
         PlaceCommand(i);
         }
      }
   for(i=1;i<=PresLastID;i++){
      if(Pres_Visible[i]==1){
         VisiblePreset(i);
         PlacePreset(i);
         }
      }
   RefStatics();
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+


